/**
 * @(#)AppletTest01.java
 *
 * AppletTest01 applet
 * <BR>
 * A simple walktrought test with some model from a game... just for fun
 *
 * 
 * @author Bruno Augier
 * @version 1.00 2007/11/07
 */

import net.dzzd.utils.Log;
 
import net.dzzd.access.*;
import net.dzzd.DzzDApplet;
import net.dzzd.*;

import java.awt.event.KeyEvent;
import java.awt.event.ComponentListener;
import java.awt.event.ComponentEvent;

import java.awt.*;
import java.net.*;
import java.awt.image.*;

import java.util.*;

public final class PANORAMA extends DzzDApplet implements Runnable
{
		
	private int nbStart=0;
	private int nbInit=0;
	IScene3DRender scene3DRender;
	Scene3DRenderCallBack mainSceneHandler;
	
	private String model1Base="PANORAMA/";		//3D model directory
	private String model1File="PANORAMA.3DS";	//3D model files


	private int loadProgress3D=0;
	private int loadProgressIMG=0;

	public void init()
	{
		super.init();
		if(this.nbInit++==0)
			this.initOnce();
	}
	
	public void start()
	{
		super.start();
		if(this.nbStart++==0)			
			this.startOnce();		
	}
	
	public void initOnce()
	{
		DzzD.extensionBaseURL=this.getBaseURL()+"/LIB/";
		this.setBackground(Color.black);
	}
	
	public void startOnce()
	{
		Thread t=new Thread(this);
		t.start();	
	}
		
	public void destroy()
	{
		this.scene3DRender.stop();
		this.scene3DRender=null;
	}
	
	public void run()
	{				
    	this.scene3DRender=DzzD.newScene3DRender();
    	IRender3D r=this.scene3DRender.getRender3D();
    	IScene3D s=this.scene3DRender.getScene3D();
		r.setScreenUpdateEnabled(false);
		r.getCanvas().setVisible(false);
		r.getCanvas().setBackground(Color.black);
		this.setLayout(null);
		this.add(r.getCanvas());
		s.setBackgroundColor(0x000000);	
		IPoint3D lRot=s.getLight3DById(0).getRotation();
		lRot.set(-0.25,0.25,0.00);


		//Ceate a 3D loader and make it monitored by the main Scene3D
		IScene3DLoader s1=DzzD.newScene3DLoader();
		s1.loadScene3D(this.getBaseURL()+this.model1Base,this.model1File);
		
		s.setScene3DLoader(s1);	
		
		do
		{

			s.updateMonitoredSceneObjects();
			if(s.getNbMonitoredSceneObject()!=0)
			{
				IMonitoredSceneObject m=s.getMonitoredSceneObject(0);
				if(m instanceof IScene3DLoader)
					this.loadProgress3D=(m.getProgress()*100)/m.getMaximumProgress();
				if(m instanceof ITexture)
					this.loadProgressIMG=(m.getProgress()*100)/m.getMaximumProgress();
				
			}
			DzzD.sleep(10);
		}
		while(s.getNbMonitoredSceneObject()!=0);

		Log.log(s1.toString());
		r.getRender3DMode().disableRender3DMode(DzzD.RM_LIGHT|DzzD.RM_TEXTURE_MIPMAP|DzzD.RM_TEXTURE_BILINEAR);
		
		r.setSize(this.getWidth(),this.getHeight());
		ICamera3D c=s.getCurrentCamera3D();
		c.setHeight(0.16);
		c.setWidth(0.9);
		c.setFOV(80);
		c.setZMin(0.1);
		c.setZoomY(((double)r.getWidth())/((double)r.getHeight()));
		//c.getPosition().setZ(-500);
		r.setScreenUpdateEnabled(true);
		r.getCanvas().setVisible(true);

		
		this.mainSceneHandler=new Scene3DRenderCallBackExamine();	
		this.scene3DRender.setScene3DRenderCallBack(this.mainSceneHandler);
		this.scene3DRender.start();	
	
	}
	
	public void paint(Graphics g)
	{
		this.update(g);
	}
	
	Font f=new Font("Verdana",Font.PLAIN,12);
	public void update(Graphics g)
	{
		if(g==null)
			return;
		if(this.mainSceneHandler==null)
		{
			int cx=this.getWidth()>>1;
			int cy=this.getHeight()>>1;
			g.setColor(Color.white);
			g.setFont(f);
			g.drawString("loading",cx-20,cy-5);
			
			int p3d=(this.loadProgress3D*140)/100;
			int pimg=(this.loadProgressIMG*140)/100;
			drawProgressBar(g,cx-70,cy,140,10,p3d,0x555555,0x0000BB,0x000055);
			drawProgressBar(g,cx-70,cy+15,140,10,pimg,0x555555,0x00BB00,0x005500);
		}
		this.validate();
		
	}	
  
    private void drawProgressBar(Graphics g,int x,int y,int w,int h,int p,int bcolor,int fcolor,int bgcolor)
    {
		g.setColor(new Color(bcolor));
		g.drawRect(x,y,w,h);
		
		if(p>=w)
			p=w-1;
				
		g.setColor(new Color(fcolor));
		g.fillRect(x+1,y+1,p,h-1);	
		
		g.setColor(new Color(bgcolor));
		g.fillRect(x+1+p,y+1,(w-p)-1,h-1);
    }
	
}
